"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CnvSummary(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "countAutosomalCnvPass",
        "countAutosomalGainPas",
        "countAutosomalLohPass",
        "countAutosomalLossCn0Pass",
        "countAutosomalLossCn1P",
        "countAutosomalLossPass",
        "log2AutosomalLossGainPass",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_3 import metrics as metrics_1_2_1

        return {
            "org.gel.models.report.avro.CnvSummary": metrics_1_2_1.CnvSummary,
        }

    __slots__ = [
        "countAutosomalCnvPass",
        "countAutosomalGainPas",
        "countAutosomalLohPass",
        "countAutosomalLossCn0Pass",
        "countAutosomalLossCn1P",
        "countAutosomalLossPass",
        "log2AutosomalLossGainPass",
    ]

    def __init__(
        self,
        countAutosomalCnvPass,
        countAutosomalGainPas,
        countAutosomalLohPass,
        countAutosomalLossCn0Pass,
        countAutosomalLossCn1P,
        countAutosomalLossPass,
        log2AutosomalLossGainPass,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_1.CnvSummary model.

        :param countAutosomalCnvPass:
            count of autosomal PASS CNVs (LOSS and GAIN)
        :type countAutosomalCnvPass: double
        :param countAutosomalGainPas:
            count of autosomal PASS GAIN callsass
        :type countAutosomalGainPas: double
        :param countAutosomalLohPass:
            count of autosomal PASS LOH callss
        :type countAutosomalLohPass: double
        :param countAutosomalLossCn0Pass:
            count of autosomal PASS LOSS calls with CN=0 (i.e. homozygous
            deletions)
        :type countAutosomalLossCn0Pass: double
        :param countAutosomalLossCn1P:
            count of autosomal PASS LOSS calls with CN=1 (i.e. heterozygous
            deletions)
        :type countAutosomalLossCn1P: double
        :param countAutosomalLossPass:
            count of auosomal PASS LOSS calls
        :type countAutosomalLossPass: double
        :param log2AutosomalLossGainPass:
            Log2 of autosomal PASS LOSS/GAIN calls ratio, (i.e.
            Log2(countAutosomalLossPass/countAutosomalGainPass) )
        :type log2AutosomalLossGainPass: double
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.1"
